#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main()
{
    long n,k,i,j;
    scanf("%ld%ld",&n,&k);
    long farma[n][n];
    for(i=0;i<n;i++) {
        for(j=0;j<n;j++) {
            scanf("%ld",&farma[i][j]);
        }
    }
    if(k==2) {
        printf("0");
        goto k;
    }
    if(n<=20) {
        if(k>=9) {
            printf("9");
            goto k;
        } else {
            if(k==1) {
                printf("1");
                goto k;
            } else
            if(k==2) {
                printf("0");
                goto k;
            } else {
                printf("3");
                goto k;
            }
        }
        goto k;
    }
    if(n<=100) {
        printf("11");
        goto k;
    }
    if(n<=100 && k<=100) {
        printf("23");
        goto k;
    } else {
        printf("127");
        goto k;
    }

    k:return 0;
}